package eu.jonahbauer.raytracing.math;

import org.jetbrains.annotations.NotNull;

/**
 * A vector-like object that implements the standard mathematical operations
 * @param <T> the type
 */
public interface IVec<T extends IVec<T>> {
    double get(int i);

    @NotNull T plus(@NotNull T other);
    @NotNull T minus(@NotNull T other);
    @NotNull T times(@NotNull T other);
    @NotNull T times(double d);
    default @NotNull T div(double d) {
        return times(1 / d);
    }

    double @NotNull[] toArray();
}
